/* currency.c generated by valac 0.26.0.50-d9a75, the Vala compiler
 * generated from currency.vala, do not modify */

/*
 * Copyright (C) 2008-2012 Robert Ancell.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gstdio.h>
#include <sys/stat.h>
#include <time.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <gio/gio.h>


#define TYPE_CURRENCY_MANAGER (currency_manager_get_type ())
#define CURRENCY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CURRENCY_MANAGER, CurrencyManager))
#define CURRENCY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CURRENCY_MANAGER, CurrencyManagerClass))
#define IS_CURRENCY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CURRENCY_MANAGER))
#define IS_CURRENCY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CURRENCY_MANAGER))
#define CURRENCY_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CURRENCY_MANAGER, CurrencyManagerClass))

typedef struct _CurrencyManager CurrencyManager;
typedef struct _CurrencyManagerClass CurrencyManagerClass;
typedef struct _CurrencyManagerPrivate CurrencyManagerPrivate;

#define TYPE_CURRENCY (currency_get_type ())
#define CURRENCY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CURRENCY, Currency))
#define CURRENCY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CURRENCY, CurrencyClass))
#define IS_CURRENCY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CURRENCY))
#define IS_CURRENCY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CURRENCY))
#define CURRENCY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CURRENCY, CurrencyClass))

typedef struct _Currency Currency;
typedef struct _CurrencyClass CurrencyClass;
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_NUMBER (number_get_type ())
#define NUMBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER, Number))
#define NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER, NumberClass))
#define IS_NUMBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER))
#define IS_NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER))
#define NUMBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER, NumberClass))

typedef struct _Number Number;
typedef struct _NumberClass NumberClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _xmlXPathFreeContext0(var) ((var == NULL) ? NULL : (var = (xmlXPathFreeContext (var), NULL)))
typedef struct _CurrencyPrivate CurrencyPrivate;

struct _CurrencyManager {
	GObject parent_instance;
	CurrencyManagerPrivate * priv;
};

struct _CurrencyManagerClass {
	GObjectClass parent_class;
};

struct _CurrencyManagerPrivate {
	GList* currencies;
};

struct _Currency {
	GObject parent_instance;
	CurrencyPrivate * priv;
};

struct _CurrencyClass {
	GObjectClass parent_class;
};

struct _CurrencyPrivate {
	Number* value;
	gchar* _name;
	gchar* _display_name;
	gchar* _symbol;
};


extern gboolean downloading_imf_rates;
gboolean downloading_imf_rates = FALSE;
extern gboolean downloading_ecb_rates;
gboolean downloading_ecb_rates = FALSE;
extern gboolean loaded_rates;
gboolean loaded_rates = FALSE;
extern CurrencyManager* default_currency_manager;
CurrencyManager* default_currency_manager = NULL;
static gpointer currency_manager_parent_class = NULL;
static gpointer currency_parent_class = NULL;

GType currency_manager_get_type (void) G_GNUC_CONST;
GType currency_get_type (void) G_GNUC_CONST;
#define CURRENCY_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CURRENCY_MANAGER, CurrencyManagerPrivate))
enum  {
	CURRENCY_MANAGER_DUMMY_PROPERTY
};
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
CurrencyManager* currency_manager_get_default (void);
CurrencyManager* currency_manager_new (void);
CurrencyManager* currency_manager_construct (GType object_type);
Currency* currency_new (const gchar* name, const gchar* display_name, const gchar* symbol);
Currency* currency_construct (GType object_type, const gchar* name, const gchar* display_name, const gchar* symbol);
GList* currency_manager_get_currencies (CurrencyManager* self);
Currency* currency_manager_get_currency (CurrencyManager* self, const gchar* name);
gchar* currency_get_name (Currency* self);
GType number_get_type (void) G_GNUC_CONST;
Number* currency_get_value (Currency* self);
gboolean number_is_negative (Number* self);
gboolean number_is_zero (Number* self);
static gchar* currency_manager_get_imf_rate_filepath (CurrencyManager* self);
static gchar* currency_manager_get_ecb_rate_filepath (CurrencyManager* self);
static Currency* currency_manager_add_currency (CurrencyManager* self, const gchar* short_name);
static gboolean currency_manager_file_needs_update (CurrencyManager* self, const gchar* filename, gdouble max_age);
static void currency_manager_load_imf_rates (CurrencyManager* self);
static void _g_free0_ (gpointer var);
Number* mp_set_from_string (const gchar* str, gint default_base);
Number* number_reciprocal (Number* self);
void currency_set_value (Currency* self, Number* value);
static void currency_manager_set_ecb_rate (CurrencyManager* self, xmlNode* node, Currency* eur_rate);
Number* number_multiply (Number* self, Number* y);
static void currency_manager_set_ecb_fixed_rate (CurrencyManager* self, const gchar* name, const gchar* value, Currency* eur_rate);
Number* number_divide (Number* self, Number* y);
static void currency_manager_load_ecb_rates (CurrencyManager* self);
static gboolean currency_manager_load_rates (CurrencyManager* self);
Number* currency_manager_get_value (CurrencyManager* self, const gchar* currency);
static void currency_manager_download_file (CurrencyManager* self, const gchar* uri, const gchar* filename, GAsyncReadyCallback callback, void* callback_target);
static void currency_manager_download_imf_cb (CurrencyManager* self, GObject* object, GAsyncResult* _result_);
static void _currency_manager_download_imf_cb_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void currency_manager_download_ecb_cb (CurrencyManager* self, GObject* object, GAsyncResult* _result_);
static void _currency_manager_download_ecb_cb_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void currency_manager_finalize (GObject* obj);
#define CURRENCY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CURRENCY, CurrencyPrivate))
enum  {
	CURRENCY_DUMMY_PROPERTY,
	CURRENCY_NAME,
	CURRENCY_DISPLAY_NAME,
	CURRENCY_SYMBOL
};
gchar* currency_get_display_name (Currency* self);
gchar* currency_get_symbol (Currency* self);
static void currency_finalize (GObject* obj);
static void _vala_currency_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void _g_object_unref0_ (gpointer var) {
#line 18 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 171 "currency.c"
}


static void _g_list_free__g_object_unref0_ (GList* self) {
#line 18 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
#line 18 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_list_free (self);
#line 180 "currency.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return self ? g_object_ref (self) : NULL;
#line 187 "currency.c"
}


CurrencyManager* currency_manager_get_default (void) {
	CurrencyManager* result = NULL;
	CurrencyManager* _tmp0_ = NULL;
	CurrencyManager* _tmp3_ = NULL;
	CurrencyManager* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	Currency* _tmp6_ = NULL;
	CurrencyManager* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	Currency* _tmp9_ = NULL;
	CurrencyManager* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	Currency* _tmp12_ = NULL;
	CurrencyManager* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	Currency* _tmp15_ = NULL;
	CurrencyManager* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	Currency* _tmp18_ = NULL;
	CurrencyManager* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	Currency* _tmp21_ = NULL;
	CurrencyManager* _tmp22_ = NULL;
	const gchar* _tmp23_ = NULL;
	Currency* _tmp24_ = NULL;
	CurrencyManager* _tmp25_ = NULL;
	const gchar* _tmp26_ = NULL;
	Currency* _tmp27_ = NULL;
	CurrencyManager* _tmp28_ = NULL;
	const gchar* _tmp29_ = NULL;
	Currency* _tmp30_ = NULL;
	CurrencyManager* _tmp31_ = NULL;
	const gchar* _tmp32_ = NULL;
	Currency* _tmp33_ = NULL;
	CurrencyManager* _tmp34_ = NULL;
	const gchar* _tmp35_ = NULL;
	Currency* _tmp36_ = NULL;
	CurrencyManager* _tmp37_ = NULL;
	const gchar* _tmp38_ = NULL;
	Currency* _tmp39_ = NULL;
	CurrencyManager* _tmp40_ = NULL;
	const gchar* _tmp41_ = NULL;
	Currency* _tmp42_ = NULL;
	CurrencyManager* _tmp43_ = NULL;
	const gchar* _tmp44_ = NULL;
	Currency* _tmp45_ = NULL;
	CurrencyManager* _tmp46_ = NULL;
	const gchar* _tmp47_ = NULL;
	Currency* _tmp48_ = NULL;
	CurrencyManager* _tmp49_ = NULL;
	const gchar* _tmp50_ = NULL;
	Currency* _tmp51_ = NULL;
	CurrencyManager* _tmp52_ = NULL;
	const gchar* _tmp53_ = NULL;
	Currency* _tmp54_ = NULL;
	CurrencyManager* _tmp55_ = NULL;
	const gchar* _tmp56_ = NULL;
	Currency* _tmp57_ = NULL;
	CurrencyManager* _tmp58_ = NULL;
	const gchar* _tmp59_ = NULL;
	Currency* _tmp60_ = NULL;
	CurrencyManager* _tmp61_ = NULL;
	const gchar* _tmp62_ = NULL;
	Currency* _tmp63_ = NULL;
	CurrencyManager* _tmp64_ = NULL;
	const gchar* _tmp65_ = NULL;
	Currency* _tmp66_ = NULL;
	CurrencyManager* _tmp67_ = NULL;
	const gchar* _tmp68_ = NULL;
	Currency* _tmp69_ = NULL;
	CurrencyManager* _tmp70_ = NULL;
	const gchar* _tmp71_ = NULL;
	Currency* _tmp72_ = NULL;
	CurrencyManager* _tmp73_ = NULL;
	const gchar* _tmp74_ = NULL;
	Currency* _tmp75_ = NULL;
	CurrencyManager* _tmp76_ = NULL;
	const gchar* _tmp77_ = NULL;
	Currency* _tmp78_ = NULL;
	CurrencyManager* _tmp79_ = NULL;
	const gchar* _tmp80_ = NULL;
	Currency* _tmp81_ = NULL;
	CurrencyManager* _tmp82_ = NULL;
	const gchar* _tmp83_ = NULL;
	Currency* _tmp84_ = NULL;
	CurrencyManager* _tmp85_ = NULL;
	const gchar* _tmp86_ = NULL;
	Currency* _tmp87_ = NULL;
	CurrencyManager* _tmp88_ = NULL;
	const gchar* _tmp89_ = NULL;
	Currency* _tmp90_ = NULL;
	CurrencyManager* _tmp91_ = NULL;
	const gchar* _tmp92_ = NULL;
	Currency* _tmp93_ = NULL;
	CurrencyManager* _tmp94_ = NULL;
	const gchar* _tmp95_ = NULL;
	Currency* _tmp96_ = NULL;
	CurrencyManager* _tmp97_ = NULL;
	const gchar* _tmp98_ = NULL;
	Currency* _tmp99_ = NULL;
	CurrencyManager* _tmp100_ = NULL;
	const gchar* _tmp101_ = NULL;
	Currency* _tmp102_ = NULL;
	CurrencyManager* _tmp103_ = NULL;
	const gchar* _tmp104_ = NULL;
	Currency* _tmp105_ = NULL;
	CurrencyManager* _tmp106_ = NULL;
	const gchar* _tmp107_ = NULL;
	Currency* _tmp108_ = NULL;
	CurrencyManager* _tmp109_ = NULL;
	const gchar* _tmp110_ = NULL;
	Currency* _tmp111_ = NULL;
	CurrencyManager* _tmp112_ = NULL;
	const gchar* _tmp113_ = NULL;
	Currency* _tmp114_ = NULL;
	CurrencyManager* _tmp115_ = NULL;
	const gchar* _tmp116_ = NULL;
	Currency* _tmp117_ = NULL;
	CurrencyManager* _tmp118_ = NULL;
	const gchar* _tmp119_ = NULL;
	Currency* _tmp120_ = NULL;
	CurrencyManager* _tmp121_ = NULL;
	const gchar* _tmp122_ = NULL;
	Currency* _tmp123_ = NULL;
	CurrencyManager* _tmp124_ = NULL;
	const gchar* _tmp125_ = NULL;
	Currency* _tmp126_ = NULL;
	CurrencyManager* _tmp127_ = NULL;
	const gchar* _tmp128_ = NULL;
	Currency* _tmp129_ = NULL;
	CurrencyManager* _tmp130_ = NULL;
	const gchar* _tmp131_ = NULL;
	Currency* _tmp132_ = NULL;
	CurrencyManager* _tmp133_ = NULL;
	const gchar* _tmp134_ = NULL;
	Currency* _tmp135_ = NULL;
	CurrencyManager* _tmp136_ = NULL;
	const gchar* _tmp137_ = NULL;
	Currency* _tmp138_ = NULL;
	CurrencyManager* _tmp139_ = NULL;
	const gchar* _tmp140_ = NULL;
	Currency* _tmp141_ = NULL;
	CurrencyManager* _tmp142_ = NULL;
	const gchar* _tmp143_ = NULL;
	Currency* _tmp144_ = NULL;
	CurrencyManager* _tmp145_ = NULL;
	const gchar* _tmp146_ = NULL;
	Currency* _tmp147_ = NULL;
	CurrencyManager* _tmp148_ = NULL;
	const gchar* _tmp149_ = NULL;
	Currency* _tmp150_ = NULL;
	CurrencyManager* _tmp151_ = NULL;
	const gchar* _tmp152_ = NULL;
	Currency* _tmp153_ = NULL;
	CurrencyManager* _tmp154_ = NULL;
	const gchar* _tmp155_ = NULL;
	Currency* _tmp156_ = NULL;
	CurrencyManager* _tmp157_ = NULL;
	const gchar* _tmp158_ = NULL;
	Currency* _tmp159_ = NULL;
	CurrencyManager* _tmp160_ = NULL;
	const gchar* _tmp161_ = NULL;
	Currency* _tmp162_ = NULL;
	CurrencyManager* _tmp163_ = NULL;
	const gchar* _tmp164_ = NULL;
	Currency* _tmp165_ = NULL;
	CurrencyManager* _tmp166_ = NULL;
	const gchar* _tmp167_ = NULL;
	Currency* _tmp168_ = NULL;
	CurrencyManager* _tmp169_ = NULL;
	const gchar* _tmp170_ = NULL;
	Currency* _tmp171_ = NULL;
	CurrencyManager* _tmp172_ = NULL;
	const gchar* _tmp173_ = NULL;
	Currency* _tmp174_ = NULL;
	CurrencyManager* _tmp175_ = NULL;
	const gchar* _tmp176_ = NULL;
	Currency* _tmp177_ = NULL;
	CurrencyManager* _tmp178_ = NULL;
	const gchar* _tmp179_ = NULL;
	Currency* _tmp180_ = NULL;
	CurrencyManager* _tmp181_ = NULL;
	CurrencyManager* _tmp182_ = NULL;
#line 23 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = default_currency_manager;
#line 23 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp0_ != NULL) {
#line 378 "currency.c"
		CurrencyManager* _tmp1_ = NULL;
		CurrencyManager* _tmp2_ = NULL;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp1_ = default_currency_manager;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		result = _tmp2_;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return result;
#line 389 "currency.c"
	}
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp3_ = currency_manager_new ();
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (default_currency_manager);
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	default_currency_manager = _tmp3_;
#line 28 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp4_ = default_currency_manager;
#line 28 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp5_ = _ ("UAE Dirham");
#line 28 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp6_ = currency_new ("AED", _tmp5_, "إ.د");
#line 28 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp4_->priv->currencies = g_list_append (_tmp4_->priv->currencies, _tmp6_);
#line 29 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp7_ = default_currency_manager;
#line 29 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp8_ = _ ("Australian Dollar");
#line 29 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp9_ = currency_new ("AUD", _tmp8_, "$");
#line 29 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp7_->priv->currencies = g_list_append (_tmp7_->priv->currencies, _tmp9_);
#line 30 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp10_ = default_currency_manager;
#line 30 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp11_ = _ ("Bulgarian Lev");
#line 30 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp12_ = currency_new ("BGN", _tmp11_, "лв");
#line 30 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp10_->priv->currencies = g_list_append (_tmp10_->priv->currencies, _tmp12_);
#line 31 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp13_ = default_currency_manager;
#line 31 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp14_ = _ ("Bahraini Dinar");
#line 31 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp15_ = currency_new ("BHD", _tmp14_, ".ب.د");
#line 31 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp13_->priv->currencies = g_list_append (_tmp13_->priv->currencies, _tmp15_);
#line 32 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp16_ = default_currency_manager;
#line 32 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp17_ = _ ("Brunei Dollar");
#line 32 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp18_ = currency_new ("BND", _tmp17_, "$");
#line 32 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp16_->priv->currencies = g_list_append (_tmp16_->priv->currencies, _tmp18_);
#line 33 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp19_ = default_currency_manager;
#line 33 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp20_ = _ ("Brazilian Real");
#line 33 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp21_ = currency_new ("BRL", _tmp20_, "R$");
#line 33 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp19_->priv->currencies = g_list_append (_tmp19_->priv->currencies, _tmp21_);
#line 34 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp22_ = default_currency_manager;
#line 34 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp23_ = _ ("Botswana Pula");
#line 34 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp24_ = currency_new ("BWP", _tmp23_, "P");
#line 34 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp22_->priv->currencies = g_list_append (_tmp22_->priv->currencies, _tmp24_);
#line 35 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp25_ = default_currency_manager;
#line 35 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp26_ = _ ("Canadian Dollar");
#line 35 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp27_ = currency_new ("CAD", _tmp26_, "$");
#line 35 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp25_->priv->currencies = g_list_append (_tmp25_->priv->currencies, _tmp27_);
#line 36 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp28_ = default_currency_manager;
#line 36 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp29_ = _ ("CFA Franc");
#line 36 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp30_ = currency_new ("CFA", _tmp29_, "Fr");
#line 36 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp28_->priv->currencies = g_list_append (_tmp28_->priv->currencies, _tmp30_);
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp31_ = default_currency_manager;
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp32_ = _ ("Swiss Franc");
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp33_ = currency_new ("CHF", _tmp32_, "Fr");
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp31_->priv->currencies = g_list_append (_tmp31_->priv->currencies, _tmp33_);
#line 38 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp34_ = default_currency_manager;
#line 38 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp35_ = _ ("Chilean Peso");
#line 38 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp36_ = currency_new ("CLP", _tmp35_, "$");
#line 38 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp34_->priv->currencies = g_list_append (_tmp34_->priv->currencies, _tmp36_);
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp37_ = default_currency_manager;
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp38_ = _ ("Chinese Yuan");
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp39_ = currency_new ("CNY", _tmp38_, "元");
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp37_->priv->currencies = g_list_append (_tmp37_->priv->currencies, _tmp39_);
#line 40 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp40_ = default_currency_manager;
#line 40 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp41_ = _ ("Colombian Peso");
#line 40 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp42_ = currency_new ("COP", _tmp41_, "$");
#line 40 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp40_->priv->currencies = g_list_append (_tmp40_->priv->currencies, _tmp42_);
#line 41 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp43_ = default_currency_manager;
#line 41 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp44_ = _ ("Czech Koruna");
#line 41 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp45_ = currency_new ("CZK", _tmp44_, "Kč");
#line 41 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp43_->priv->currencies = g_list_append (_tmp43_->priv->currencies, _tmp45_);
#line 42 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp46_ = default_currency_manager;
#line 42 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp47_ = _ ("Danish Krone");
#line 42 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp48_ = currency_new ("DKK", _tmp47_, "kr");
#line 42 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp46_->priv->currencies = g_list_append (_tmp46_->priv->currencies, _tmp48_);
#line 43 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp49_ = default_currency_manager;
#line 43 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp50_ = _ ("Algerian Dinar");
#line 43 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp51_ = currency_new ("DZD", _tmp50_, "ج.د");
#line 43 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp49_->priv->currencies = g_list_append (_tmp49_->priv->currencies, _tmp51_);
#line 44 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp52_ = default_currency_manager;
#line 44 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp53_ = _ ("Estonian Kroon");
#line 44 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp54_ = currency_new ("EEK", _tmp53_, "KR");
#line 44 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp52_->priv->currencies = g_list_append (_tmp52_->priv->currencies, _tmp54_);
#line 45 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp55_ = default_currency_manager;
#line 45 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp56_ = _ ("Euro");
#line 45 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp57_ = currency_new ("EUR", _tmp56_, "€");
#line 45 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp55_->priv->currencies = g_list_append (_tmp55_->priv->currencies, _tmp57_);
#line 46 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp58_ = default_currency_manager;
#line 46 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp59_ = _ ("Pound Sterling");
#line 46 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp60_ = currency_new ("GBP", _tmp59_, "£");
#line 46 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp58_->priv->currencies = g_list_append (_tmp58_->priv->currencies, _tmp60_);
#line 47 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp61_ = default_currency_manager;
#line 47 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp62_ = _ ("Hong Kong Dollar");
#line 47 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp63_ = currency_new ("HKD", _tmp62_, "$");
#line 47 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp61_->priv->currencies = g_list_append (_tmp61_->priv->currencies, _tmp63_);
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp64_ = default_currency_manager;
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp65_ = _ ("Croatian Kuna");
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp66_ = currency_new ("HRK", _tmp65_, "kn");
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp64_->priv->currencies = g_list_append (_tmp64_->priv->currencies, _tmp66_);
#line 49 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp67_ = default_currency_manager;
#line 49 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp68_ = _ ("Hungarian Forint");
#line 49 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp69_ = currency_new ("HUF", _tmp68_, "Ft");
#line 49 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp67_->priv->currencies = g_list_append (_tmp67_->priv->currencies, _tmp69_);
#line 50 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp70_ = default_currency_manager;
#line 50 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp71_ = _ ("Indonesian Rupiah");
#line 50 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp72_ = currency_new ("IDR", _tmp71_, "Rp");
#line 50 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp70_->priv->currencies = g_list_append (_tmp70_->priv->currencies, _tmp72_);
#line 51 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp73_ = default_currency_manager;
#line 51 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp74_ = _ ("Israeli New Shekel");
#line 51 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp75_ = currency_new ("ILS", _tmp74_, "₪");
#line 51 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp73_->priv->currencies = g_list_append (_tmp73_->priv->currencies, _tmp75_);
#line 52 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp76_ = default_currency_manager;
#line 52 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp77_ = _ ("Indian Rupee");
#line 52 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp78_ = currency_new ("INR", _tmp77_, "₹");
#line 52 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp76_->priv->currencies = g_list_append (_tmp76_->priv->currencies, _tmp78_);
#line 53 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp79_ = default_currency_manager;
#line 53 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp80_ = _ ("Iranian Rial");
#line 53 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp81_ = currency_new ("IRR", _tmp80_, "﷼");
#line 53 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp79_->priv->currencies = g_list_append (_tmp79_->priv->currencies, _tmp81_);
#line 54 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp82_ = default_currency_manager;
#line 54 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp83_ = _ ("Icelandic Krona");
#line 54 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp84_ = currency_new ("ISK", _tmp83_, "kr");
#line 54 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp82_->priv->currencies = g_list_append (_tmp82_->priv->currencies, _tmp84_);
#line 55 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp85_ = default_currency_manager;
#line 55 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp86_ = _ ("Japanese Yen");
#line 55 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp87_ = currency_new ("JPY", _tmp86_, "¥");
#line 55 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp85_->priv->currencies = g_list_append (_tmp85_->priv->currencies, _tmp87_);
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp88_ = default_currency_manager;
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp89_ = _ ("South Korean Won");
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp90_ = currency_new ("KRW", _tmp89_, "₩");
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp88_->priv->currencies = g_list_append (_tmp88_->priv->currencies, _tmp90_);
#line 57 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp91_ = default_currency_manager;
#line 57 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp92_ = _ ("Kuwaiti Dinar");
#line 57 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp93_ = currency_new ("KWD", _tmp92_, "ك.د");
#line 57 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp91_->priv->currencies = g_list_append (_tmp91_->priv->currencies, _tmp93_);
#line 58 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp94_ = default_currency_manager;
#line 58 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp95_ = _ ("Kazakhstani Tenge");
#line 58 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp96_ = currency_new ("KZT", _tmp95_, "₸");
#line 58 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp94_->priv->currencies = g_list_append (_tmp94_->priv->currencies, _tmp96_);
#line 59 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp97_ = default_currency_manager;
#line 59 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp98_ = _ ("Sri Lankan Rupee");
#line 59 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp99_ = currency_new ("LKR", _tmp98_, "Rs");
#line 59 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp97_->priv->currencies = g_list_append (_tmp97_->priv->currencies, _tmp99_);
#line 60 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp100_ = default_currency_manager;
#line 60 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp101_ = _ ("Lithuanian Litas");
#line 60 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp102_ = currency_new ("LTL", _tmp101_, "Lt");
#line 60 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp100_->priv->currencies = g_list_append (_tmp100_->priv->currencies, _tmp102_);
#line 61 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp103_ = default_currency_manager;
#line 61 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp104_ = _ ("Libyan Dinar");
#line 61 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp105_ = currency_new ("LYD", _tmp104_, "د.ل");
#line 61 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp103_->priv->currencies = g_list_append (_tmp103_->priv->currencies, _tmp105_);
#line 62 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp106_ = default_currency_manager;
#line 62 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp107_ = _ ("Mauritian Rupee");
#line 62 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp108_ = currency_new ("MUR", _tmp107_, "Rs");
#line 62 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp106_->priv->currencies = g_list_append (_tmp106_->priv->currencies, _tmp108_);
#line 63 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp109_ = default_currency_manager;
#line 63 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp110_ = _ ("Mexican Peso");
#line 63 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp111_ = currency_new ("MXN", _tmp110_, "$");
#line 63 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp109_->priv->currencies = g_list_append (_tmp109_->priv->currencies, _tmp111_);
#line 64 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp112_ = default_currency_manager;
#line 64 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp113_ = _ ("Malaysian Ringgit");
#line 64 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp114_ = currency_new ("MYR", _tmp113_, "RM");
#line 64 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp112_->priv->currencies = g_list_append (_tmp112_->priv->currencies, _tmp114_);
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp115_ = default_currency_manager;
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp116_ = _ ("Norwegian Krone");
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp117_ = currency_new ("NOK", _tmp116_, "kr");
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp115_->priv->currencies = g_list_append (_tmp115_->priv->currencies, _tmp117_);
#line 66 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp118_ = default_currency_manager;
#line 66 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp119_ = _ ("Nepalese Rupee");
#line 66 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp120_ = currency_new ("NPR", _tmp119_, "Rs");
#line 66 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp118_->priv->currencies = g_list_append (_tmp118_->priv->currencies, _tmp120_);
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp121_ = default_currency_manager;
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp122_ = _ ("New Zealand Dollar");
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp123_ = currency_new ("NZD", _tmp122_, "$");
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp121_->priv->currencies = g_list_append (_tmp121_->priv->currencies, _tmp123_);
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp124_ = default_currency_manager;
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp125_ = _ ("Omani Rial");
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp126_ = currency_new ("OMR", _tmp125_, "ع.ر.");
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp124_->priv->currencies = g_list_append (_tmp124_->priv->currencies, _tmp126_);
#line 69 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp127_ = default_currency_manager;
#line 69 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp128_ = _ ("Peruvian Nuevo Sol");
#line 69 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp129_ = currency_new ("PEN", _tmp128_, "S/.");
#line 69 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp127_->priv->currencies = g_list_append (_tmp127_->priv->currencies, _tmp129_);
#line 70 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp130_ = default_currency_manager;
#line 70 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp131_ = _ ("Philippine Peso");
#line 70 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp132_ = currency_new ("PHP", _tmp131_, "₱");
#line 70 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp130_->priv->currencies = g_list_append (_tmp130_->priv->currencies, _tmp132_);
#line 71 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp133_ = default_currency_manager;
#line 71 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp134_ = _ ("Pakistani Rupee");
#line 71 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp135_ = currency_new ("PKR", _tmp134_, "Rs");
#line 71 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp133_->priv->currencies = g_list_append (_tmp133_->priv->currencies, _tmp135_);
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp136_ = default_currency_manager;
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp137_ = _ ("Polish Zloty");
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp138_ = currency_new ("PLN", _tmp137_, "zł");
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp136_->priv->currencies = g_list_append (_tmp136_->priv->currencies, _tmp138_);
#line 73 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp139_ = default_currency_manager;
#line 73 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp140_ = _ ("Qatari Riyal");
#line 73 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp141_ = currency_new ("QAR", _tmp140_, "ق.ر");
#line 73 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp139_->priv->currencies = g_list_append (_tmp139_->priv->currencies, _tmp141_);
#line 74 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp142_ = default_currency_manager;
#line 74 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp143_ = _ ("New Romanian Leu");
#line 74 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp144_ = currency_new ("RON", _tmp143_, "L");
#line 74 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp142_->priv->currencies = g_list_append (_tmp142_->priv->currencies, _tmp144_);
#line 75 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp145_ = default_currency_manager;
#line 75 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp146_ = _ ("Russian Rouble");
#line 75 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp147_ = currency_new ("RUB", _tmp146_, "руб.");
#line 75 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp145_->priv->currencies = g_list_append (_tmp145_->priv->currencies, _tmp147_);
#line 76 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp148_ = default_currency_manager;
#line 76 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp149_ = _ ("Saudi Riyal");
#line 76 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp150_ = currency_new ("SAR", _tmp149_, "س.ر");
#line 76 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp148_->priv->currencies = g_list_append (_tmp148_->priv->currencies, _tmp150_);
#line 77 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp151_ = default_currency_manager;
#line 77 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp152_ = _ ("Swedish Krona");
#line 77 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp153_ = currency_new ("SEK", _tmp152_, "kr");
#line 77 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp151_->priv->currencies = g_list_append (_tmp151_->priv->currencies, _tmp153_);
#line 78 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp154_ = default_currency_manager;
#line 78 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp155_ = _ ("Singapore Dollar");
#line 78 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp156_ = currency_new ("SGD", _tmp155_, "$");
#line 78 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp154_->priv->currencies = g_list_append (_tmp154_->priv->currencies, _tmp156_);
#line 79 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp157_ = default_currency_manager;
#line 79 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp158_ = _ ("Thai Baht");
#line 79 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp159_ = currency_new ("THB", _tmp158_, "฿");
#line 79 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp157_->priv->currencies = g_list_append (_tmp157_->priv->currencies, _tmp159_);
#line 80 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp160_ = default_currency_manager;
#line 80 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp161_ = _ ("Tunisian Dinar");
#line 80 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp162_ = currency_new ("TND", _tmp161_, "ت.د");
#line 80 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp160_->priv->currencies = g_list_append (_tmp160_->priv->currencies, _tmp162_);
#line 81 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp163_ = default_currency_manager;
#line 81 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp164_ = _ ("New Turkish Lira");
#line 81 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp165_ = currency_new ("TRY", _tmp164_, "TL");
#line 81 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp163_->priv->currencies = g_list_append (_tmp163_->priv->currencies, _tmp165_);
#line 82 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp166_ = default_currency_manager;
#line 82 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp167_ = _ ("T&T Dollar (TTD)");
#line 82 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp168_ = currency_new ("TTD", _tmp167_, "$");
#line 82 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp166_->priv->currencies = g_list_append (_tmp166_->priv->currencies, _tmp168_);
#line 83 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp169_ = default_currency_manager;
#line 83 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp170_ = _ ("US Dollar");
#line 83 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp171_ = currency_new ("USD", _tmp170_, "$");
#line 83 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp169_->priv->currencies = g_list_append (_tmp169_->priv->currencies, _tmp171_);
#line 84 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp172_ = default_currency_manager;
#line 84 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp173_ = _ ("Uruguayan Peso");
#line 84 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp174_ = currency_new ("UYU", _tmp173_, "$");
#line 84 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp172_->priv->currencies = g_list_append (_tmp172_->priv->currencies, _tmp174_);
#line 85 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp175_ = default_currency_manager;
#line 85 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp176_ = _ ("Venezuelan Bolívar");
#line 85 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp177_ = currency_new ("VEF", _tmp176_, "Bs F");
#line 85 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp175_->priv->currencies = g_list_append (_tmp175_->priv->currencies, _tmp177_);
#line 86 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp178_ = default_currency_manager;
#line 86 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp179_ = _ ("South African Rand");
#line 86 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp180_ = currency_new ("ZAR", _tmp179_, "R");
#line 86 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp178_->priv->currencies = g_list_append (_tmp178_->priv->currencies, _tmp180_);
#line 88 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp181_ = default_currency_manager;
#line 88 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp182_ = _g_object_ref0 (_tmp181_);
#line 88 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	result = _tmp182_;
#line 88 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return result;
#line 877 "currency.c"
}


GList* currency_manager_get_currencies (CurrencyManager* self) {
	GList* result = NULL;
	GList* r = NULL;
	GList* _tmp0_ = NULL;
#line 91 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 93 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	r = NULL;
#line 94 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = self->priv->currencies;
#line 891 "currency.c"
	{
		GList* c_collection = NULL;
		GList* c_it = NULL;
#line 94 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		c_collection = _tmp0_;
#line 94 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		for (c_it = c_collection; c_it != NULL; c_it = c_it->next) {
#line 899 "currency.c"
			Currency* _tmp1_ = NULL;
			Currency* c = NULL;
#line 94 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			_tmp1_ = _g_object_ref0 ((Currency*) c_it->data);
#line 94 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			c = _tmp1_;
#line 906 "currency.c"
			{
				Currency* _tmp2_ = NULL;
				Currency* _tmp3_ = NULL;
#line 95 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp2_ = c;
#line 95 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 95 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				r = g_list_append (r, _tmp3_);
#line 94 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_g_object_unref0 (c);
#line 918 "currency.c"
			}
		}
	}
#line 96 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	result = r;
#line 96 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return result;
#line 926 "currency.c"
}


Currency* currency_manager_get_currency (CurrencyManager* self, const gchar* name) {
	Currency* result = NULL;
	GList* _tmp0_ = NULL;
#line 99 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = self->priv->currencies;
#line 939 "currency.c"
	{
		GList* c_collection = NULL;
		GList* c_it = NULL;
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		c_collection = _tmp0_;
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		for (c_it = c_collection; c_it != NULL; c_it = c_it->next) {
#line 947 "currency.c"
			Currency* _tmp1_ = NULL;
			Currency* c = NULL;
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			_tmp1_ = _g_object_ref0 ((Currency*) c_it->data);
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			c = _tmp1_;
#line 954 "currency.c"
			{
				const gchar* _tmp2_ = NULL;
				Currency* _tmp3_ = NULL;
				gchar* _tmp4_ = NULL;
				gchar* _tmp5_ = NULL;
				gchar* _tmp6_ = NULL;
				gboolean _tmp7_ = FALSE;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp2_ = name;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp3_ = c;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp4_ = currency_get_name (_tmp3_);
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp5_ = _tmp4_;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp6_ = _tmp5_;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp7_ = g_strcmp0 (_tmp2_, _tmp6_) == 0;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_g_free0 (_tmp6_);
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (_tmp7_) {
#line 978 "currency.c"
					Number* value = NULL;
					Currency* _tmp8_ = NULL;
					Number* _tmp9_ = NULL;
					gboolean _tmp10_ = FALSE;
					gboolean _tmp11_ = FALSE;
					Number* _tmp12_ = NULL;
#line 105 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp8_ = c;
#line 105 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp9_ = currency_get_value (_tmp8_);
#line 105 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					value = _tmp9_;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp12_ = value;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					if (_tmp12_ == NULL) {
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp11_ = TRUE;
#line 997 "currency.c"
					} else {
						Number* _tmp13_ = NULL;
						gboolean _tmp14_ = FALSE;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp13_ = value;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp14_ = number_is_negative (_tmp13_);
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp11_ = _tmp14_;
#line 1007 "currency.c"
					}
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					if (_tmp11_) {
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp10_ = TRUE;
#line 1013 "currency.c"
					} else {
						Number* _tmp15_ = NULL;
						gboolean _tmp16_ = FALSE;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp15_ = value;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp16_ = number_is_zero (_tmp15_);
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp10_ = _tmp16_;
#line 1023 "currency.c"
					}
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					if (_tmp10_) {
#line 107 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						result = NULL;
#line 107 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_g_object_unref0 (value);
#line 107 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_g_object_unref0 (c);
#line 107 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						return result;
#line 1035 "currency.c"
					} else {
#line 109 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						result = c;
#line 109 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_g_object_unref0 (value);
#line 109 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						return result;
#line 1043 "currency.c"
					}
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_g_object_unref0 (value);
#line 1047 "currency.c"
				}
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_g_object_unref0 (c);
#line 1051 "currency.c"
			}
		}
	}
#line 113 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	result = NULL;
#line 113 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return result;
#line 1059 "currency.c"
}


static gchar* currency_manager_get_imf_rate_filepath (CurrencyManager* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 116 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = g_build_filename (_tmp0_, "gnome-calculator", "rms_five.xls", NULL);
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	result = _tmp1_;
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return result;
#line 1077 "currency.c"
}


static gchar* currency_manager_get_ecb_rate_filepath (CurrencyManager* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 121 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 123 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 123 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = g_build_filename (_tmp0_, "gnome-calculator", "eurofxref-daily.xml", NULL);
#line 123 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	result = _tmp1_;
#line 123 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return result;
#line 1095 "currency.c"
}


static Currency* currency_manager_add_currency (CurrencyManager* self, const gchar* short_name) {
	Currency* result = NULL;
	GList* _tmp0_ = NULL;
	const gchar* _tmp8_ = NULL;
	Currency* c = NULL;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	Currency* _tmp12_ = NULL;
	Currency* _tmp13_ = NULL;
	Currency* _tmp14_ = NULL;
#line 126 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 126 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (short_name != NULL, NULL);
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = self->priv->currencies;
#line 1116 "currency.c"
	{
		GList* c_collection = NULL;
		GList* c_it = NULL;
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		c_collection = _tmp0_;
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		for (c_it = c_collection; c_it != NULL; c_it = c_it->next) {
#line 1124 "currency.c"
			Currency* _tmp1_ = NULL;
			Currency* c = NULL;
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			_tmp1_ = _g_object_ref0 ((Currency*) c_it->data);
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			c = _tmp1_;
#line 1131 "currency.c"
			{
				Currency* _tmp2_ = NULL;
				gchar* _tmp3_ = NULL;
				gchar* _tmp4_ = NULL;
				gchar* _tmp5_ = NULL;
				const gchar* _tmp6_ = NULL;
				gboolean _tmp7_ = FALSE;
#line 129 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp2_ = c;
#line 129 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp3_ = currency_get_name (_tmp2_);
#line 129 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp4_ = _tmp3_;
#line 129 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp5_ = _tmp4_;
#line 129 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp6_ = short_name;
#line 129 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp7_ = g_strcmp0 (_tmp5_, _tmp6_) == 0;
#line 129 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_g_free0 (_tmp5_);
#line 129 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (_tmp7_) {
#line 130 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					result = c;
#line 130 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					return result;
#line 1159 "currency.c"
				}
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_g_object_unref0 (c);
#line 1163 "currency.c"
			}
		}
	}
#line 132 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp8_ = short_name;
#line 132 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_warning ("currency.vala:132: Currency %s is not in the currency table", _tmp8_);
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp9_ = short_name;
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp10_ = short_name;
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp11_ = short_name;
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp12_ = currency_new (_tmp9_, _tmp10_, _tmp11_);
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	c = _tmp12_;
#line 134 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp13_ = c;
#line 134 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 134 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	self->priv->currencies = g_list_append (self->priv->currencies, _tmp14_);
#line 136 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	result = c;
#line 136 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return result;
#line 1191 "currency.c"
}


static gboolean currency_manager_file_needs_update (CurrencyManager* self, const gchar* filename, gdouble max_age) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	struct stat buf = {0};
	const gchar* _tmp2_ = NULL;
	struct stat _tmp3_ = {0};
	gint _tmp4_ = 0;
	time_t modify_time = 0;
	struct stat _tmp5_ = {0};
	time_t _tmp6_ = 0;
	time_t now = 0;
	time_t _tmp7_ = 0;
	time_t _tmp8_ = 0;
	time_t _tmp9_ = 0;
	gdouble _tmp10_ = 0.0;
#line 142 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 142 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 144 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = filename;
#line 144 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = g_file_test (_tmp0_, G_FILE_TEST_IS_REGULAR);
#line 144 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (!_tmp1_) {
#line 145 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		result = TRUE;
#line 145 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return result;
#line 1225 "currency.c"
	}
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	memset (&buf, 0, sizeof (struct stat));
#line 148 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp2_ = filename;
#line 148 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp4_ = stat (_tmp2_, &_tmp3_);
#line 148 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	buf = _tmp3_;
#line 148 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp4_ == (-1)) {
#line 149 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		result = TRUE;
#line 149 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return result;
#line 1241 "currency.c"
	}
#line 151 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp5_ = buf;
#line 151 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp6_ = _tmp5_.st_mtime;
#line 151 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	modify_time = _tmp6_;
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp7_ = time (NULL);
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	now = _tmp7_;
#line 153 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp8_ = now;
#line 153 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp9_ = modify_time;
#line 153 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp10_ = max_age;
#line 153 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (((gdouble) (_tmp8_ - _tmp9_)) > _tmp10_) {
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		result = TRUE;
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return result;
#line 1265 "currency.c"
	}
#line 156 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	result = FALSE;
#line 156 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return result;
#line 1271 "currency.c"
}


static void _g_free0_ (gpointer var) {
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	var = (g_free (var), NULL);
#line 1278 "currency.c"
}


static gchar* string_chug (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 1107 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1108 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1108 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1109 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1109 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	g_strchug (_tmp1_);
#line 1110 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	result = _result_;
#line 1110 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	return result;
#line 1301 "currency.c"
}


static void currency_manager_load_imf_rates (CurrencyManager* self) {
	GHashTable* name_map = NULL;
	GHashFunc _tmp0_ = NULL;
	GEqualFunc _tmp1_ = NULL;
	GHashTable* _tmp2_ = NULL;
	GHashTable* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	GHashTable* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	GHashTable* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	GHashTable* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	GHashTable* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	GHashTable* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	GHashTable* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	GHashTable* _tmp24_ = NULL;
	gchar* _tmp25_ = NULL;
	gchar* _tmp26_ = NULL;
	GHashTable* _tmp27_ = NULL;
	gchar* _tmp28_ = NULL;
	gchar* _tmp29_ = NULL;
	GHashTable* _tmp30_ = NULL;
	gchar* _tmp31_ = NULL;
	gchar* _tmp32_ = NULL;
	GHashTable* _tmp33_ = NULL;
	gchar* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	GHashTable* _tmp36_ = NULL;
	gchar* _tmp37_ = NULL;
	gchar* _tmp38_ = NULL;
	GHashTable* _tmp39_ = NULL;
	gchar* _tmp40_ = NULL;
	gchar* _tmp41_ = NULL;
	GHashTable* _tmp42_ = NULL;
	gchar* _tmp43_ = NULL;
	gchar* _tmp44_ = NULL;
	GHashTable* _tmp45_ = NULL;
	gchar* _tmp46_ = NULL;
	gchar* _tmp47_ = NULL;
	GHashTable* _tmp48_ = NULL;
	gchar* _tmp49_ = NULL;
	gchar* _tmp50_ = NULL;
	GHashTable* _tmp51_ = NULL;
	gchar* _tmp52_ = NULL;
	gchar* _tmp53_ = NULL;
	GHashTable* _tmp54_ = NULL;
	gchar* _tmp55_ = NULL;
	gchar* _tmp56_ = NULL;
	GHashTable* _tmp57_ = NULL;
	gchar* _tmp58_ = NULL;
	gchar* _tmp59_ = NULL;
	GHashTable* _tmp60_ = NULL;
	gchar* _tmp61_ = NULL;
	gchar* _tmp62_ = NULL;
	GHashTable* _tmp63_ = NULL;
	gchar* _tmp64_ = NULL;
	gchar* _tmp65_ = NULL;
	GHashTable* _tmp66_ = NULL;
	gchar* _tmp67_ = NULL;
	gchar* _tmp68_ = NULL;
	GHashTable* _tmp69_ = NULL;
	gchar* _tmp70_ = NULL;
	gchar* _tmp71_ = NULL;
	GHashTable* _tmp72_ = NULL;
	gchar* _tmp73_ = NULL;
	gchar* _tmp74_ = NULL;
	GHashTable* _tmp75_ = NULL;
	gchar* _tmp76_ = NULL;
	gchar* _tmp77_ = NULL;
	GHashTable* _tmp78_ = NULL;
	gchar* _tmp79_ = NULL;
	gchar* _tmp80_ = NULL;
	GHashTable* _tmp81_ = NULL;
	gchar* _tmp82_ = NULL;
	gchar* _tmp83_ = NULL;
	GHashTable* _tmp84_ = NULL;
	gchar* _tmp85_ = NULL;
	gchar* _tmp86_ = NULL;
	GHashTable* _tmp87_ = NULL;
	gchar* _tmp88_ = NULL;
	gchar* _tmp89_ = NULL;
	GHashTable* _tmp90_ = NULL;
	gchar* _tmp91_ = NULL;
	gchar* _tmp92_ = NULL;
	GHashTable* _tmp93_ = NULL;
	gchar* _tmp94_ = NULL;
	gchar* _tmp95_ = NULL;
	GHashTable* _tmp96_ = NULL;
	gchar* _tmp97_ = NULL;
	gchar* _tmp98_ = NULL;
	GHashTable* _tmp99_ = NULL;
	gchar* _tmp100_ = NULL;
	gchar* _tmp101_ = NULL;
	GHashTable* _tmp102_ = NULL;
	gchar* _tmp103_ = NULL;
	gchar* _tmp104_ = NULL;
	GHashTable* _tmp105_ = NULL;
	gchar* _tmp106_ = NULL;
	gchar* _tmp107_ = NULL;
	GHashTable* _tmp108_ = NULL;
	gchar* _tmp109_ = NULL;
	gchar* _tmp110_ = NULL;
	GHashTable* _tmp111_ = NULL;
	gchar* _tmp112_ = NULL;
	gchar* _tmp113_ = NULL;
	GHashTable* _tmp114_ = NULL;
	gchar* _tmp115_ = NULL;
	gchar* _tmp116_ = NULL;
	GHashTable* _tmp117_ = NULL;
	gchar* _tmp118_ = NULL;
	gchar* _tmp119_ = NULL;
	GHashTable* _tmp120_ = NULL;
	gchar* _tmp121_ = NULL;
	gchar* _tmp122_ = NULL;
	GHashTable* _tmp123_ = NULL;
	gchar* _tmp124_ = NULL;
	gchar* _tmp125_ = NULL;
	GHashTable* _tmp126_ = NULL;
	gchar* _tmp127_ = NULL;
	gchar* _tmp128_ = NULL;
	GHashTable* _tmp129_ = NULL;
	gchar* _tmp130_ = NULL;
	gchar* _tmp131_ = NULL;
	GHashTable* _tmp132_ = NULL;
	gchar* _tmp133_ = NULL;
	gchar* _tmp134_ = NULL;
	GHashTable* _tmp135_ = NULL;
	gchar* _tmp136_ = NULL;
	gchar* _tmp137_ = NULL;
	GHashTable* _tmp138_ = NULL;
	gchar* _tmp139_ = NULL;
	gchar* _tmp140_ = NULL;
	GHashTable* _tmp141_ = NULL;
	gchar* _tmp142_ = NULL;
	gchar* _tmp143_ = NULL;
	GHashTable* _tmp144_ = NULL;
	gchar* _tmp145_ = NULL;
	gchar* _tmp146_ = NULL;
	GHashTable* _tmp147_ = NULL;
	gchar* _tmp148_ = NULL;
	gchar* _tmp149_ = NULL;
	GHashTable* _tmp150_ = NULL;
	gchar* _tmp151_ = NULL;
	gchar* _tmp152_ = NULL;
	GHashTable* _tmp153_ = NULL;
	gchar* _tmp154_ = NULL;
	gchar* _tmp155_ = NULL;
	gchar* filename = NULL;
	gchar* _tmp156_ = NULL;
	gchar* data = NULL;
	gchar** lines = NULL;
	const gchar* _tmp161_ = NULL;
	gchar** _tmp162_ = NULL;
	gchar** _tmp163_ = NULL;
	gint lines_length1 = 0;
	gint _lines_size_ = 0;
	gboolean in_data = FALSE;
	gchar** _tmp164_ = NULL;
	gint _tmp164__length1 = 0;
	GError * _inner_error_ = NULL;
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (self != NULL);
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = g_str_hash;
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = g_str_equal;
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	name_map = _tmp2_;
#line 162 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp3_ = name_map;
#line 162 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp4_ = g_strdup ("Euro");
#line 162 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp5_ = g_strdup ("EUR");
#line 162 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp3_, _tmp4_, _tmp5_);
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp6_ = name_map;
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp7_ = g_strdup ("Japanese Yen");
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp8_ = g_strdup ("JPY");
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp6_, _tmp7_, _tmp8_);
#line 164 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp9_ = name_map;
#line 164 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp10_ = g_strdup ("U.K. Pound Sterling");
#line 164 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp11_ = g_strdup ("GBP");
#line 164 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp9_, _tmp10_, _tmp11_);
#line 165 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp12_ = name_map;
#line 165 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp13_ = g_strdup ("U.S. Dollar");
#line 165 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp14_ = g_strdup ("USD");
#line 165 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp12_, _tmp13_, _tmp14_);
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp15_ = name_map;
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp16_ = g_strdup ("Algerian Dinar");
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp17_ = g_strdup ("DZD");
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp15_, _tmp16_, _tmp17_);
#line 167 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp18_ = name_map;
#line 167 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp19_ = g_strdup ("Australian Dollar");
#line 167 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp20_ = g_strdup ("AUD");
#line 167 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp18_, _tmp19_, _tmp20_);
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp21_ = name_map;
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp22_ = g_strdup ("Bahrain Dinar");
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp23_ = g_strdup ("BHD");
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp21_, _tmp22_, _tmp23_);
#line 169 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp24_ = name_map;
#line 169 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp25_ = g_strdup ("Botswana Pula");
#line 169 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp26_ = g_strdup ("BWP");
#line 169 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp24_, _tmp25_, _tmp26_);
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp27_ = name_map;
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp28_ = g_strdup ("Brazilian Real");
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp29_ = g_strdup ("BRL");
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp27_, _tmp28_, _tmp29_);
#line 171 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp30_ = name_map;
#line 171 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp31_ = g_strdup ("Brunei Dollar");
#line 171 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp32_ = g_strdup ("BND");
#line 171 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp30_, _tmp31_, _tmp32_);
#line 172 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp33_ = name_map;
#line 172 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp34_ = g_strdup ("Canadian Dollar");
#line 172 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp35_ = g_strdup ("CAD");
#line 172 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp33_, _tmp34_, _tmp35_);
#line 173 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp36_ = name_map;
#line 173 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp37_ = g_strdup ("Chilean Peso");
#line 173 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp38_ = g_strdup ("CLP");
#line 173 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp36_, _tmp37_, _tmp38_);
#line 174 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp39_ = name_map;
#line 174 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp40_ = g_strdup ("Chinese Yuan");
#line 174 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp41_ = g_strdup ("CNY");
#line 174 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp39_, _tmp40_, _tmp41_);
#line 175 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp42_ = name_map;
#line 175 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp43_ = g_strdup ("Colombian Peso");
#line 175 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp44_ = g_strdup ("COP");
#line 175 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp42_, _tmp43_, _tmp44_);
#line 176 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp45_ = name_map;
#line 176 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp46_ = g_strdup ("Czech Koruna");
#line 176 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp47_ = g_strdup ("CZK");
#line 176 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp45_, _tmp46_, _tmp47_);
#line 177 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp48_ = name_map;
#line 177 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp49_ = g_strdup ("Danish Krone");
#line 177 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp50_ = g_strdup ("DKK");
#line 177 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp48_, _tmp49_, _tmp50_);
#line 178 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp51_ = name_map;
#line 178 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp52_ = g_strdup ("Hungarian Forint");
#line 178 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp53_ = g_strdup ("HUF");
#line 178 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp51_, _tmp52_, _tmp53_);
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp54_ = name_map;
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp55_ = g_strdup ("Icelandic Krona");
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp56_ = g_strdup ("ISK");
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp54_, _tmp55_, _tmp56_);
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp57_ = name_map;
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp58_ = g_strdup ("Indian Rupee");
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp59_ = g_strdup ("INR");
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp57_, _tmp58_, _tmp59_);
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp60_ = name_map;
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp61_ = g_strdup ("Indonesian Rupiah");
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp62_ = g_strdup ("IDR");
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp60_, _tmp61_, _tmp62_);
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp63_ = name_map;
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp64_ = g_strdup ("Iranian Rial");
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp65_ = g_strdup ("IRR");
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp63_, _tmp64_, _tmp65_);
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp66_ = name_map;
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp67_ = g_strdup ("Israeli New Sheqel");
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp68_ = g_strdup ("ILS");
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp66_, _tmp67_, _tmp68_);
#line 184 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp69_ = name_map;
#line 184 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp70_ = g_strdup ("Kazakhstani Tenge");
#line 184 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp71_ = g_strdup ("KZT");
#line 184 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp69_, _tmp70_, _tmp71_);
#line 185 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp72_ = name_map;
#line 185 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp73_ = g_strdup ("Korean Won");
#line 185 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp74_ = g_strdup ("KRW");
#line 185 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp72_, _tmp73_, _tmp74_);
#line 186 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp75_ = name_map;
#line 186 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp76_ = g_strdup ("Kuwaiti Dinar");
#line 186 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp77_ = g_strdup ("KWD");
#line 186 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp75_, _tmp76_, _tmp77_);
#line 187 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp78_ = name_map;
#line 187 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp79_ = g_strdup ("Libyan Dinar");
#line 187 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp80_ = g_strdup ("LYD");
#line 187 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp78_, _tmp79_, _tmp80_);
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp81_ = name_map;
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp82_ = g_strdup ("Malaysian Ringgit");
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp83_ = g_strdup ("MYR");
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp81_, _tmp82_, _tmp83_);
#line 189 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp84_ = name_map;
#line 189 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp85_ = g_strdup ("Mauritian Rupee");
#line 189 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp86_ = g_strdup ("MUR");
#line 189 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp84_, _tmp85_, _tmp86_);
#line 190 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp87_ = name_map;
#line 190 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp88_ = g_strdup ("Mexican Peso");
#line 190 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp89_ = g_strdup ("MXN");
#line 190 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp87_, _tmp88_, _tmp89_);
#line 191 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp90_ = name_map;
#line 191 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp91_ = g_strdup ("Nepalese Rupee");
#line 191 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp92_ = g_strdup ("NPR");
#line 191 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp90_, _tmp91_, _tmp92_);
#line 192 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp93_ = name_map;
#line 192 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp94_ = g_strdup ("New Zealand Dollar");
#line 192 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp95_ = g_strdup ("NZD");
#line 192 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp93_, _tmp94_, _tmp95_);
#line 193 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp96_ = name_map;
#line 193 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp97_ = g_strdup ("Norwegian Krone");
#line 193 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp98_ = g_strdup ("NOK");
#line 193 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp96_, _tmp97_, _tmp98_);
#line 194 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp99_ = name_map;
#line 194 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp100_ = g_strdup ("Rial Omani");
#line 194 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp101_ = g_strdup ("OMR");
#line 194 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp99_, _tmp100_, _tmp101_);
#line 195 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp102_ = name_map;
#line 195 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp103_ = g_strdup ("Pakistani Rupee");
#line 195 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp104_ = g_strdup ("PKR");
#line 195 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp102_, _tmp103_, _tmp104_);
#line 196 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp105_ = name_map;
#line 196 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp106_ = g_strdup ("Nuevo Sol");
#line 196 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp107_ = g_strdup ("PEN");
#line 196 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp105_, _tmp106_, _tmp107_);
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp108_ = name_map;
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp109_ = g_strdup ("Philippine Peso");
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp110_ = g_strdup ("PHP");
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp108_, _tmp109_, _tmp110_);
#line 198 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp111_ = name_map;
#line 198 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp112_ = g_strdup ("Polish Zloty");
#line 198 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp113_ = g_strdup ("PLN");
#line 198 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp111_, _tmp112_, _tmp113_);
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp114_ = name_map;
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp115_ = g_strdup ("Qatar Riyal");
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp116_ = g_strdup ("QAR");
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp114_, _tmp115_, _tmp116_);
#line 200 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp117_ = name_map;
#line 200 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp118_ = g_strdup ("Russian Ruble");
#line 200 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp119_ = g_strdup ("RUB");
#line 200 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp117_, _tmp118_, _tmp119_);
#line 201 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp120_ = name_map;
#line 201 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp121_ = g_strdup ("Saudi Arabian Riyal");
#line 201 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp122_ = g_strdup ("SAR");
#line 201 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp120_, _tmp121_, _tmp122_);
#line 202 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp123_ = name_map;
#line 202 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp124_ = g_strdup ("Singapore Dollar");
#line 202 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp125_ = g_strdup ("SGD");
#line 202 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp123_, _tmp124_, _tmp125_);
#line 203 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp126_ = name_map;
#line 203 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp127_ = g_strdup ("South African Rand");
#line 203 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp128_ = g_strdup ("ZAR");
#line 203 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp126_, _tmp127_, _tmp128_);
#line 204 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp129_ = name_map;
#line 204 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp130_ = g_strdup ("Sri Lanka Rupee");
#line 204 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp131_ = g_strdup ("LKR");
#line 204 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp129_, _tmp130_, _tmp131_);
#line 205 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp132_ = name_map;
#line 205 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp133_ = g_strdup ("Swedish Krona");
#line 205 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp134_ = g_strdup ("SEK");
#line 205 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp132_, _tmp133_, _tmp134_);
#line 206 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp135_ = name_map;
#line 206 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp136_ = g_strdup ("Swiss Franc");
#line 206 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp137_ = g_strdup ("CHF");
#line 206 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp135_, _tmp136_, _tmp137_);
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp138_ = name_map;
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp139_ = g_strdup ("Thai Baht");
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp140_ = g_strdup ("THB");
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp138_, _tmp139_, _tmp140_);
#line 208 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp141_ = name_map;
#line 208 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp142_ = g_strdup ("Trinidad And Tobago Dollar");
#line 208 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp143_ = g_strdup ("TTD");
#line 208 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp141_, _tmp142_, _tmp143_);
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp144_ = name_map;
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp145_ = g_strdup ("Tunisian Dinar");
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp146_ = g_strdup ("TND");
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp144_, _tmp145_, _tmp146_);
#line 210 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp147_ = name_map;
#line 210 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp148_ = g_strdup ("U.A.E. Dirham");
#line 210 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp149_ = g_strdup ("AED");
#line 210 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp147_, _tmp148_, _tmp149_);
#line 211 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp150_ = name_map;
#line 211 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp151_ = g_strdup ("Peso Uruguayo");
#line 211 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp152_ = g_strdup ("UYU");
#line 211 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp150_, _tmp151_, _tmp152_);
#line 212 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp153_ = name_map;
#line 212 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp154_ = g_strdup ("Bolivar Fuerte");
#line 212 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp155_ = g_strdup ("VEF");
#line 212 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_hash_table_insert (_tmp153_, _tmp154_, _tmp155_);
#line 214 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp156_ = currency_manager_get_imf_rate_filepath (self);
#line 214 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	filename = _tmp156_;
#line 1898 "currency.c"
	{
		const gchar* _tmp157_ = NULL;
		gchar* _tmp158_ = NULL;
#line 218 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp157_ = filename;
#line 218 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_file_get_contents (_tmp157_, &_tmp158_, NULL, &_inner_error_);
#line 218 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_free0 (data);
#line 218 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		data = _tmp158_;
#line 218 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1912 "currency.c"
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp159_ = NULL;
		const gchar* _tmp160_ = NULL;
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		e = _inner_error_;
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_inner_error_ = NULL;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp159_ = e;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp160_ = _tmp159_->message;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_warning ("currency.vala:222: Failed to read exchange rates: %s", _tmp160_);
#line 223 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_error_free0 (e);
#line 223 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_free0 (data);
#line 223 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_free0 (filename);
#line 223 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_hash_table_unref0 (name_map);
#line 223 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return;
#line 1942 "currency.c"
	}
	__finally3:
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_free0 (data);
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_free0 (filename);
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_hash_table_unref0 (name_map);
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_clear_error (&_inner_error_);
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return;
#line 1959 "currency.c"
	}
#line 226 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp161_ = data;
#line 226 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp163_ = _tmp162_ = g_strsplit (_tmp161_, "\n", 0);
#line 226 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	lines = _tmp163_;
#line 226 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	lines_length1 = _vala_array_length (_tmp162_);
#line 226 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_lines_size_ = lines_length1;
#line 228 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	in_data = FALSE;
#line 229 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp164_ = lines;
#line 229 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp164__length1 = lines_length1;
#line 1977 "currency.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 229 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		line_collection = _tmp164_;
#line 229 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		line_collection_length1 = _tmp164__length1;
#line 229 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		for (line_it = 0; line_it < _tmp164__length1; line_it = line_it + 1) {
#line 1989 "currency.c"
			gchar* _tmp165_ = NULL;
			gchar* line = NULL;
#line 229 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			_tmp165_ = g_strdup (line_collection[line_it]);
#line 229 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			line = _tmp165_;
#line 1996 "currency.c"
			{
				const gchar* _tmp166_ = NULL;
				gchar* _tmp167_ = NULL;
				const gchar* _tmp168_ = NULL;
				gboolean _tmp170_ = FALSE;
				gchar** tokens = NULL;
				const gchar* _tmp171_ = NULL;
				gchar** _tmp172_ = NULL;
				gchar** _tmp173_ = NULL;
				gint tokens_length1 = 0;
				gint _tokens_size_ = 0;
				gchar** _tmp174_ = NULL;
				gint _tmp174__length1 = 0;
				const gchar* _tmp175_ = NULL;
#line 231 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp166_ = line;
#line 231 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp167_ = string_chug (_tmp166_);
#line 231 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_g_free0 (line);
#line 231 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				line = _tmp167_;
#line 234 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp168_ = line;
#line 234 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (g_strcmp0 (_tmp168_, "") == 0) {
#line 2023 "currency.c"
					gboolean _tmp169_ = FALSE;
#line 236 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp169_ = in_data;
#line 236 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					if (!_tmp169_) {
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						in_data = TRUE;
#line 239 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_g_free0 (line);
#line 239 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						continue;
#line 2035 "currency.c"
					} else {
#line 242 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_g_free0 (line);
#line 242 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						break;
#line 2041 "currency.c"
					}
				}
#line 244 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp170_ = in_data;
#line 244 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (!_tmp170_) {
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_g_free0 (line);
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					continue;
#line 2052 "currency.c"
				}
#line 247 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp171_ = line;
#line 247 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp173_ = _tmp172_ = g_strsplit (_tmp171_, "\t", 0);
#line 247 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				tokens = _tmp173_;
#line 247 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				tokens_length1 = _vala_array_length (_tmp172_);
#line 247 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tokens_size_ = tokens_length1;
#line 248 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp174_ = tokens;
#line 248 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp174__length1 = tokens_length1;
#line 248 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp175_ = _tmp174_[0];
#line 248 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (g_strcmp0 (_tmp175_, "Currency") != 0) {
#line 2072 "currency.c"
					gint value_index = 0;
					gint _tmp185_ = 0;
					gchar** _tmp186_ = NULL;
					gint _tmp186__length1 = 0;
					{
						gboolean _tmp176_ = FALSE;
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						value_index = 1;
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp176_ = TRUE;
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						while (TRUE) {
#line 2085 "currency.c"
							gint _tmp178_ = 0;
							gchar** _tmp179_ = NULL;
							gint _tmp179__length1 = 0;
							gchar* value = NULL;
							gchar** _tmp180_ = NULL;
							gint _tmp180__length1 = 0;
							gint _tmp181_ = 0;
							const gchar* _tmp182_ = NULL;
							gchar* _tmp183_ = NULL;
							const gchar* _tmp184_ = NULL;
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							if (!_tmp176_) {
#line 2098 "currency.c"
								gint _tmp177_ = 0;
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								_tmp177_ = value_index;
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								value_index = _tmp177_ + 1;
#line 2104 "currency.c"
							}
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp176_ = FALSE;
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp178_ = value_index;
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp179_ = tokens;
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp179__length1 = tokens_length1;
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							if (!(_tmp178_ < _tmp179__length1)) {
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								break;
#line 2118 "currency.c"
							}
#line 253 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp180_ = tokens;
#line 253 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp180__length1 = tokens_length1;
#line 253 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp181_ = value_index;
#line 253 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp182_ = _tmp180_[_tmp181_];
#line 253 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp183_ = string_chug (_tmp182_);
#line 253 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							value = _tmp183_;
#line 254 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp184_ = value;
#line 254 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							if (g_strcmp0 (_tmp184_, "") != 0) {
#line 255 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								_g_free0 (value);
#line 255 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								break;
#line 2140 "currency.c"
							}
#line 251 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_g_free0 (value);
#line 2144 "currency.c"
						}
					}
#line 258 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp185_ = value_index;
#line 258 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp186_ = tokens;
#line 258 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp186__length1 = tokens_length1;
#line 258 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					if (_tmp185_ < _tmp186__length1) {
#line 2155 "currency.c"
						gchar* symbol = NULL;
						GHashTable* _tmp187_ = NULL;
						gchar** _tmp188_ = NULL;
						gint _tmp188__length1 = 0;
						const gchar* _tmp189_ = NULL;
						gconstpointer _tmp190_ = NULL;
						gchar* _tmp191_ = NULL;
						const gchar* _tmp192_ = NULL;
#line 260 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp187_ = name_map;
#line 260 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp188_ = tokens;
#line 260 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp188__length1 = tokens_length1;
#line 260 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp189_ = _tmp188_[0];
#line 260 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp190_ = g_hash_table_lookup (_tmp187_, _tmp189_);
#line 260 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp191_ = g_strdup ((const gchar*) _tmp190_);
#line 260 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						symbol = _tmp191_;
#line 261 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp192_ = symbol;
#line 261 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						if (_tmp192_ != NULL) {
#line 2182 "currency.c"
							Currency* c = NULL;
							const gchar* _tmp193_ = NULL;
							Currency* _tmp194_ = NULL;
							Currency* _tmp195_ = NULL;
							Number* value = NULL;
							gchar** _tmp202_ = NULL;
							gint _tmp202__length1 = 0;
							gint _tmp203_ = 0;
							const gchar* _tmp204_ = NULL;
							Number* _tmp205_ = NULL;
							Number* _tmp206_ = NULL;
							Number* _tmp207_ = NULL;
							Currency* _tmp208_ = NULL;
							Number* _tmp209_ = NULL;
#line 263 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp193_ = symbol;
#line 263 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp194_ = currency_manager_get_currency (self, _tmp193_);
#line 263 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							c = _tmp194_;
#line 264 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp195_ = c;
#line 264 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							if (_tmp195_ == NULL) {
#line 2207 "currency.c"
								gchar** _tmp196_ = NULL;
								gint _tmp196__length1 = 0;
								gint _tmp197_ = 0;
								const gchar* _tmp198_ = NULL;
								const gchar* _tmp199_ = NULL;
								const gchar* _tmp200_ = NULL;
								Currency* _tmp201_ = NULL;
#line 266 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								_tmp196_ = tokens;
#line 266 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								_tmp196__length1 = tokens_length1;
#line 266 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								_tmp197_ = value_index;
#line 266 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								_tmp198_ = _tmp196_[_tmp197_];
#line 266 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								_tmp199_ = symbol;
#line 266 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								g_debug ("currency.vala:266: Using IMF rate of %s for %s", _tmp198_, _tmp199_);
#line 267 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								_tmp200_ = symbol;
#line 267 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								_tmp201_ = currency_manager_add_currency (self, _tmp200_);
#line 267 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								_g_object_unref0 (c);
#line 267 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
								c = _tmp201_;
#line 2235 "currency.c"
							}
#line 269 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp202_ = tokens;
#line 269 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp202__length1 = tokens_length1;
#line 269 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp203_ = value_index;
#line 269 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp204_ = _tmp202_[_tmp203_];
#line 269 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp205_ = mp_set_from_string (_tmp204_, 10);
#line 269 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							value = _tmp205_;
#line 270 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp206_ = value;
#line 270 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp207_ = number_reciprocal (_tmp206_);
#line 270 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_g_object_unref0 (value);
#line 270 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							value = _tmp207_;
#line 271 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp208_ = c;
#line 271 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp209_ = value;
#line 271 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							currency_set_value (_tmp208_, _tmp209_);
#line 261 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_g_object_unref0 (value);
#line 261 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_g_object_unref0 (c);
#line 2267 "currency.c"
						} else {
							gchar** _tmp210_ = NULL;
							gint _tmp210__length1 = 0;
							const gchar* _tmp211_ = NULL;
#line 274 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp210_ = tokens;
#line 274 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp210__length1 = tokens_length1;
#line 274 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							_tmp211_ = _tmp210_[0];
#line 274 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
							g_warning ("currency.vala:274: Unknown currency '%s'", _tmp211_);
#line 2280 "currency.c"
						}
#line 258 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_g_free0 (symbol);
#line 2284 "currency.c"
					}
				}
#line 229 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 229 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_g_free0 (line);
#line 2291 "currency.c"
			}
		}
	}
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (data);
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (filename);
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_hash_table_unref0 (name_map);
#line 2303 "currency.c"
}


static void currency_manager_set_ecb_rate (CurrencyManager* self, xmlNode* node, Currency* eur_rate) {
	gchar* name = NULL;
	gchar* value = NULL;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	const gchar* _tmp17_ = NULL;
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (self != NULL);
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (node != NULL);
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (eur_rate != NULL);
#line 282 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	name = NULL;
#line 282 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	value = NULL;
#line 2323 "currency.c"
	{
		xmlAttr* attribute = NULL;
		xmlNode* _tmp0_ = NULL;
		xmlAttr* _tmp1_ = NULL;
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp0_ = node;
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp1_ = _tmp0_->properties;
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		attribute = _tmp1_;
#line 2334 "currency.c"
		{
			gboolean _tmp2_ = FALSE;
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			_tmp2_ = TRUE;
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			while (TRUE) {
#line 2341 "currency.c"
				xmlAttr* _tmp5_ = NULL;
				xmlNode* n = NULL;
				xmlAttr* _tmp6_ = NULL;
				xmlAttr* _tmp7_ = NULL;
				const gchar* _tmp8_ = NULL;
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (!_tmp2_) {
#line 2349 "currency.c"
					xmlAttr* _tmp3_ = NULL;
					xmlAttr* _tmp4_ = NULL;
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp3_ = attribute;
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp4_ = _tmp3_->next;
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					attribute = _tmp4_;
#line 2358 "currency.c"
				}
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp2_ = FALSE;
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp5_ = attribute;
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (!(_tmp5_ != NULL)) {
#line 284 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					break;
#line 2368 "currency.c"
				}
#line 286 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp6_ = attribute;
#line 286 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				n = (xmlNode*) _tmp6_;
#line 287 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp7_ = attribute;
#line 287 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp8_ = _tmp7_->name;
#line 287 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (g_strcmp0 (_tmp8_, "currency") == 0) {
#line 2380 "currency.c"
					xmlNode* _tmp9_ = NULL;
					gchar* _tmp10_ = NULL;
#line 288 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp9_ = n;
#line 288 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp10_ = (gchar*) xmlNodeGetContent (_tmp9_);
#line 288 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_g_free0 (name);
#line 288 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					name = _tmp10_;
#line 2391 "currency.c"
				} else {
					xmlAttr* _tmp11_ = NULL;
					const gchar* _tmp12_ = NULL;
#line 289 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp11_ = attribute;
#line 289 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp12_ = _tmp11_->name;
#line 289 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					if (g_strcmp0 (_tmp12_, "rate") == 0) {
#line 2401 "currency.c"
						xmlNode* _tmp13_ = NULL;
						gchar* _tmp14_ = NULL;
#line 290 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp13_ = n;
#line 290 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_tmp14_ = (gchar*) xmlNodeGetContent (_tmp13_);
#line 290 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						_g_free0 (value);
#line 290 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
						value = _tmp14_;
#line 2412 "currency.c"
					}
				}
			}
		}
	}
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp17_ = name;
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp17_ != NULL) {
#line 2422 "currency.c"
		const gchar* _tmp18_ = NULL;
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp18_ = value;
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp16_ = _tmp18_ != NULL;
#line 2428 "currency.c"
	} else {
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp16_ = FALSE;
#line 2432 "currency.c"
	}
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp16_) {
#line 2436 "currency.c"
		const gchar* _tmp19_ = NULL;
		Currency* _tmp20_ = NULL;
		Currency* _tmp21_ = NULL;
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp19_ = name;
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp20_ = currency_manager_get_currency (self, _tmp19_);
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp21_ = _tmp20_;
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp15_ = _tmp21_ == NULL;
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (_tmp21_);
#line 2450 "currency.c"
	} else {
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp15_ = FALSE;
#line 2454 "currency.c"
	}
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp15_) {
#line 2458 "currency.c"
		const gchar* _tmp22_ = NULL;
		const gchar* _tmp23_ = NULL;
		Currency* c = NULL;
		const gchar* _tmp24_ = NULL;
		Currency* _tmp25_ = NULL;
		Number* r = NULL;
		const gchar* _tmp26_ = NULL;
		Number* _tmp27_ = NULL;
		Number* v = NULL;
		Currency* _tmp28_ = NULL;
		Number* _tmp29_ = NULL;
		Number* _tmp30_ = NULL;
		Number* _tmp31_ = NULL;
		Number* _tmp32_ = NULL;
		Currency* _tmp33_ = NULL;
		Number* _tmp34_ = NULL;
#line 296 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp22_ = value;
#line 296 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp23_ = name;
#line 296 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_debug ("currency.vala:296: Using ECB rate of %s for %s", _tmp22_, _tmp23_);
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp24_ = name;
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp25_ = currency_manager_add_currency (self, _tmp24_);
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		c = _tmp25_;
#line 298 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp26_ = value;
#line 298 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp27_ = mp_set_from_string (_tmp26_, 10);
#line 298 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		r = _tmp27_;
#line 299 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp28_ = eur_rate;
#line 299 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp29_ = currency_get_value (_tmp28_);
#line 299 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		v = _tmp29_;
#line 300 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp30_ = v;
#line 300 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp31_ = r;
#line 300 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp32_ = number_multiply (_tmp30_, _tmp31_);
#line 300 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (v);
#line 300 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		v = _tmp32_;
#line 301 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp33_ = c;
#line 301 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp34_ = v;
#line 301 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		currency_set_value (_tmp33_, _tmp34_);
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (v);
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (r);
#line 294 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (c);
#line 2521 "currency.c"
	}
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (value);
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (name);
#line 2527 "currency.c"
}


static void currency_manager_set_ecb_fixed_rate (CurrencyManager* self, const gchar* name, const gchar* value, Currency* eur_rate) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	Currency* c = NULL;
	const gchar* _tmp2_ = NULL;
	Currency* _tmp3_ = NULL;
	Number* r = NULL;
	const gchar* _tmp4_ = NULL;
	Number* _tmp5_ = NULL;
	Number* v = NULL;
	Currency* _tmp6_ = NULL;
	Number* _tmp7_ = NULL;
	Number* _tmp8_ = NULL;
	Number* _tmp9_ = NULL;
	Number* _tmp10_ = NULL;
#line 305 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (self != NULL);
#line 305 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (name != NULL);
#line 305 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (value != NULL);
#line 305 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (eur_rate != NULL);
#line 307 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = value;
#line 307 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = name;
#line 307 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_debug ("currency.vala:307: Using ECB fixed rate of %s for %s", _tmp0_, _tmp1_);
#line 308 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp2_ = name;
#line 308 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp3_ = currency_manager_add_currency (self, _tmp2_);
#line 308 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	c = _tmp3_;
#line 309 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp4_ = value;
#line 309 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp5_ = mp_set_from_string (_tmp4_, 10);
#line 309 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	r = _tmp5_;
#line 310 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp6_ = eur_rate;
#line 310 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp7_ = currency_get_value (_tmp6_);
#line 310 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	v = _tmp7_;
#line 311 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp8_ = v;
#line 311 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp9_ = number_divide (_tmp8_, r);
#line 311 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (v);
#line 311 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	v = _tmp9_;
#line 312 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp10_ = v;
#line 312 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	currency_set_value (c, _tmp10_);
#line 305 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (v);
#line 305 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (r);
#line 305 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (c);
#line 2596 "currency.c"
}


static void currency_manager_load_ecb_rates (CurrencyManager* self) {
	Currency* eur_rate = NULL;
	Currency* _tmp0_ = NULL;
	Currency* _tmp1_ = NULL;
	Currency* _tmp2_ = NULL;
	Currency* _tmp3_ = NULL;
	gchar* filename = NULL;
	gchar* _tmp4_ = NULL;
	xmlDoc* document = NULL;
	const gchar* _tmp5_ = NULL;
	xmlDoc* _tmp6_ = NULL;
	xmlDoc* _tmp7_ = NULL;
	xmlXPathContext* xpath_ctx = NULL;
	xmlDoc* _tmp9_ = NULL;
	xmlXPathContext* _tmp10_ = NULL;
	xmlXPathContext* _tmp11_ = NULL;
	xmlXPathContext* _tmp12_ = NULL;
	xmlXPathObject* xpath_obj = NULL;
	xmlXPathContext* _tmp13_ = NULL;
	xmlXPathObject* _tmp14_ = NULL;
	xmlXPathObject* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	xmlXPathObject* _tmp17_ = NULL;
	xmlNodeSet* _tmp18_ = NULL;
	gint len = 0;
#line 315 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (self != NULL);
#line 318 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = currency_manager_get_currency (self, "EUR");
#line 318 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	eur_rate = _tmp0_;
#line 319 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = eur_rate;
#line 319 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp1_ == NULL) {
#line 321 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_warning ("currency.vala:321: Cannot use ECB rates as don't have EUR rate");
#line 322 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (eur_rate);
#line 322 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return;
#line 2641 "currency.c"
	}
#line 326 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp2_ = eur_rate;
#line 326 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	currency_manager_set_ecb_fixed_rate (self, "EEK", "0.06391", _tmp2_);
#line 327 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp3_ = eur_rate;
#line 327 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	currency_manager_set_ecb_fixed_rate (self, "CFA", "0.152449", _tmp3_);
#line 329 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	xmlInitParser ();
#line 330 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp4_ = currency_manager_get_ecb_rate_filepath (self);
#line 330 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	filename = _tmp4_;
#line 331 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp5_ = filename;
#line 331 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp6_ = xmlReadFile (_tmp5_, NULL, 0);
#line 331 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	document = _tmp6_;
#line 332 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp7_ = document;
#line 332 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp7_ == NULL) {
#line 2667 "currency.c"
		const gchar* _tmp8_ = NULL;
#line 334 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp8_ = filename;
#line 334 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_warning ("currency.vala:334: Couldn't parse ECB rate file %s", _tmp8_);
#line 335 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_free0 (filename);
#line 335 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (eur_rate);
#line 335 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return;
#line 2679 "currency.c"
	}
#line 338 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp9_ = document;
#line 338 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp10_ = xmlXPathNewContext (_tmp9_);
#line 338 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	xpath_ctx = _tmp10_;
#line 339 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp11_ = xpath_ctx;
#line 339 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp11_ == NULL) {
#line 341 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_warning ("currency.vala:341: Couldn't create XPath context");
#line 342 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_xmlXPathFreeContext0 (xpath_ctx);
#line 342 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_free0 (filename);
#line 342 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (eur_rate);
#line 342 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return;
#line 2701 "currency.c"
	}
#line 345 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp12_ = xpath_ctx;
#line 345 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	xmlXPathRegisterNs (_tmp12_, (xmlChar*) "xref", (xmlChar*) "http://www.ecb.int/vocabulary/2002-08-01/eurofxref");
#line 346 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp13_ = xpath_ctx;
#line 346 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp14_ = xmlXPathEvalExpression ((xmlChar*) "//xref:Cube[@currency][@rate]", _tmp13_);
#line 346 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	xpath_obj = _tmp14_;
#line 347 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp15_ = xpath_obj;
#line 347 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp15_ == NULL) {
#line 349 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_warning ("currency.vala:349: Couldn't create XPath object");
#line 350 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_xmlXPathFreeContext0 (xpath_ctx);
#line 350 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_free0 (filename);
#line 350 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (eur_rate);
#line 350 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return;
#line 2727 "currency.c"
	}
#line 352 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp17_ = xpath_obj;
#line 352 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp18_ = _tmp17_->nodesetval;
#line 352 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp18_ != NULL) {
#line 2735 "currency.c"
		xmlXPathObject* _tmp19_ = NULL;
		xmlNodeSet* _tmp20_ = NULL;
		gint _tmp21_ = 0;
#line 352 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp19_ = xpath_obj;
#line 352 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp20_ = _tmp19_->nodesetval;
#line 352 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp21_ = xmlXPathNodeSetGetLength (_tmp20_);
#line 352 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp16_ = _tmp21_;
#line 2747 "currency.c"
	} else {
#line 352 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp16_ = 0;
#line 2751 "currency.c"
	}
#line 352 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	len = _tmp16_;
#line 2755 "currency.c"
	{
		gint i = 0;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		i = 0;
#line 2760 "currency.c"
		{
			gboolean _tmp22_ = FALSE;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			_tmp22_ = TRUE;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			while (TRUE) {
#line 2767 "currency.c"
				gint _tmp24_ = 0;
				gint _tmp25_ = 0;
				xmlNode* node = NULL;
				xmlXPathObject* _tmp26_ = NULL;
				xmlNodeSet* _tmp27_ = NULL;
				gint _tmp28_ = 0;
				xmlNode* _tmp29_ = NULL;
				xmlNode* _tmp30_ = NULL;
				xmlElementType _tmp31_ = 0;
				xmlNode* _tmp34_ = NULL;
				xmlElementType _tmp35_ = 0;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (!_tmp22_) {
#line 2781 "currency.c"
					gint _tmp23_ = 0;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp23_ = i;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					i = _tmp23_ + 1;
#line 2787 "currency.c"
				}
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp22_ = FALSE;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp24_ = i;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp25_ = len;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (!(_tmp24_ < _tmp25_)) {
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					break;
#line 2799 "currency.c"
				}
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp26_ = xpath_obj;
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp27_ = _tmp26_->nodesetval;
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp28_ = i;
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp29_ = xmlXPathNodeSetItem (_tmp27_, _tmp28_);
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				node = _tmp29_;
#line 357 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp30_ = node;
#line 357 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp31_ = _tmp30_->type;
#line 357 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (_tmp31_ == XML_ELEMENT_NODE) {
#line 2817 "currency.c"
					xmlNode* _tmp32_ = NULL;
					Currency* _tmp33_ = NULL;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp32_ = node;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp33_ = eur_rate;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					currency_manager_set_ecb_rate (self, _tmp32_, _tmp33_);
#line 2826 "currency.c"
				}
#line 361 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp34_ = node;
#line 361 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp35_ = _tmp34_->type;
#line 361 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (_tmp35_ != XML_NAMESPACE_DECL) {
#line 362 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					node = NULL;
#line 2836 "currency.c"
				}
			}
		}
	}
#line 365 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	xmlCleanupParser ();
#line 315 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_xmlXPathFreeContext0 (xpath_ctx);
#line 315 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (filename);
#line 315 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (eur_rate);
#line 2849 "currency.c"
}


static gboolean currency_manager_load_rates (CurrencyManager* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GList* _tmp4_ = NULL;
#line 368 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 371 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = loaded_rates;
#line 371 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp0_) {
#line 372 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		result = TRUE;
#line 372 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return result;
#line 2869 "currency.c"
	}
#line 375 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp2_ = downloading_imf_rates;
#line 375 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp2_) {
#line 375 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp1_ = TRUE;
#line 2877 "currency.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 375 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp3_ = downloading_ecb_rates;
#line 375 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp1_ = _tmp3_;
#line 2884 "currency.c"
	}
#line 375 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp1_) {
#line 376 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		result = FALSE;
#line 376 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return result;
#line 2892 "currency.c"
	}
#line 379 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	currency_manager_load_imf_rates (self);
#line 380 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	currency_manager_load_ecb_rates (self);
#line 383 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp4_ = self->priv->currencies;
#line 2900 "currency.c"
	{
		GList* c_collection = NULL;
		GList* c_it = NULL;
#line 383 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		c_collection = _tmp4_;
#line 383 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		for (c_it = c_collection; c_it != NULL; c_it = c_it->next) {
#line 2908 "currency.c"
			Currency* _tmp5_ = NULL;
			Currency* c = NULL;
#line 383 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			_tmp5_ = _g_object_ref0 ((Currency*) c_it->data);
#line 383 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
			c = _tmp5_;
#line 2915 "currency.c"
			{
				gboolean _tmp6_ = FALSE;
				Currency* _tmp7_ = NULL;
				Number* _tmp8_ = NULL;
				Number* _tmp9_ = NULL;
				gboolean _tmp10_ = FALSE;
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp7_ = c;
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp8_ = currency_get_value (_tmp7_);
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp9_ = _tmp8_;
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_tmp10_ = _tmp9_ == NULL;
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_g_object_unref0 (_tmp9_);
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (_tmp10_) {
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp6_ = TRUE;
#line 2936 "currency.c"
				} else {
					Currency* _tmp11_ = NULL;
					Number* _tmp12_ = NULL;
					Number* _tmp13_ = NULL;
					gboolean _tmp14_ = FALSE;
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp11_ = c;
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp12_ = currency_get_value (_tmp11_);
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp13_ = _tmp12_;
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp14_ = number_is_zero (_tmp13_);
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp6_ = _tmp14_;
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_g_object_unref0 (_tmp13_);
#line 2954 "currency.c"
				}
#line 384 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				if (_tmp6_) {
#line 2958 "currency.c"
					Currency* _tmp15_ = NULL;
					gchar* _tmp16_ = NULL;
					gchar* _tmp17_ = NULL;
					gchar* _tmp18_ = NULL;
#line 385 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp15_ = c;
#line 385 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp16_ = currency_get_name (_tmp15_);
#line 385 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp17_ = _tmp16_;
#line 385 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_tmp18_ = _tmp17_;
#line 385 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					g_warning ("currency.vala:385: Currency %s is not provided by IMF or ECB", _tmp18_);
#line 385 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
					_g_free0 (_tmp18_);
#line 2975 "currency.c"
				}
#line 383 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
				_g_object_unref0 (c);
#line 2979 "currency.c"
			}
		}
	}
#line 387 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_debug ("currency.vala:387: Rates loaded");
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	loaded_rates = TRUE;
#line 390 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_signal_emit_by_name (self, "updated");
#line 392 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	result = TRUE;
#line 392 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return result;
#line 2993 "currency.c"
}


static void _currency_manager_download_imf_cb_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	currency_manager_download_imf_cb ((CurrencyManager*) self, source_object, res);
#line 3000 "currency.c"
}


static void _currency_manager_download_ecb_cb_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 410 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	currency_manager_download_ecb_cb ((CurrencyManager*) self, source_object, res);
#line 3007 "currency.c"
}


Number* currency_manager_get_value (CurrencyManager* self, const gchar* currency) {
	Number* result = NULL;
	gchar* path = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp12_ = FALSE;
	Currency* c = NULL;
	const gchar* _tmp13_ = NULL;
	Currency* _tmp14_ = NULL;
	Currency* _tmp15_ = NULL;
#line 395 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 395 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (currency != NULL, NULL);
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = currency_manager_get_imf_rate_filepath (self);
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	path = _tmp0_;
#line 399 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp2_ = downloading_imf_rates;
#line 399 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (!_tmp2_) {
#line 3037 "currency.c"
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
#line 399 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp3_ = path;
#line 399 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp4_ = currency_manager_file_needs_update (self, _tmp3_, (gdouble) (((60 * 60) * 24) * 7));
#line 399 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp1_ = _tmp4_;
#line 3046 "currency.c"
	} else {
#line 399 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp1_ = FALSE;
#line 3050 "currency.c"
	}
#line 399 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp1_) {
#line 3054 "currency.c"
		const gchar* _tmp5_ = NULL;
#line 401 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		downloading_imf_rates = TRUE;
#line 402 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_debug ("currency.vala:402: Downloading rates from the IMF...");
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp5_ = path;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		currency_manager_download_file (self, "http://www.imf.org/external/np/fin/data/rms_five.aspx?tsvflag=Y", _tmp5_, _currency_manager_download_imf_cb_gasync_ready_callback, self);
#line 3064 "currency.c"
	}
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp6_ = currency_manager_get_ecb_rate_filepath (self);
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (path);
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	path = _tmp6_;
#line 406 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp8_ = downloading_ecb_rates;
#line 406 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (!_tmp8_) {
#line 3076 "currency.c"
		const gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
#line 406 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp9_ = path;
#line 406 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp10_ = currency_manager_file_needs_update (self, _tmp9_, (gdouble) (((60 * 60) * 24) * 7));
#line 406 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp7_ = _tmp10_;
#line 3085 "currency.c"
	} else {
#line 406 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp7_ = FALSE;
#line 3089 "currency.c"
	}
#line 406 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp7_) {
#line 3093 "currency.c"
		const gchar* _tmp11_ = NULL;
#line 408 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		downloading_ecb_rates = TRUE;
#line 409 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_debug ("currency.vala:409: Downloading rates from the ECB...");
#line 410 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp11_ = path;
#line 410 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		currency_manager_download_file (self, "http://www.ecb.europa.eu/stats/eurofxref/eurofxref-daily.xml", _tmp11_, _currency_manager_download_ecb_cb_gasync_ready_callback, self);
#line 3103 "currency.c"
	}
#line 413 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp12_ = currency_manager_load_rates (self);
#line 413 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (!_tmp12_) {
#line 414 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		result = NULL;
#line 414 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_free0 (path);
#line 414 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return result;
#line 3115 "currency.c"
	}
#line 416 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp13_ = currency;
#line 416 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp14_ = currency_manager_get_currency (self, _tmp13_);
#line 416 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	c = _tmp14_;
#line 417 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp15_ = c;
#line 417 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (_tmp15_ != NULL) {
#line 3127 "currency.c"
		Currency* _tmp16_ = NULL;
		Number* _tmp17_ = NULL;
#line 418 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp16_ = c;
#line 418 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp17_ = currency_get_value (_tmp16_);
#line 418 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		result = _tmp17_;
#line 418 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (c);
#line 418 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_free0 (path);
#line 418 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return result;
#line 3142 "currency.c"
	} else {
#line 420 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		result = NULL;
#line 420 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (c);
#line 420 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_free0 (path);
#line 420 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return result;
#line 3152 "currency.c"
	}
#line 395 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (c);
#line 395 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (path);
#line 3158 "currency.c"
}


static void currency_manager_download_file (CurrencyManager* self, const gchar* uri, const gchar* filename, GAsyncReadyCallback callback, void* callback_target) {
	gchar* directory = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GFile* source = NULL;
	const gchar* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* dest = NULL;
	const gchar* _tmp4_ = NULL;
	GFile* _tmp5_ = NULL;
	GAsyncReadyCallback _tmp6_ = NULL;
	void* _tmp6__target = NULL;
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (self != NULL);
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (uri != NULL);
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (filename != NULL);
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = filename;
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = g_path_get_dirname (_tmp0_);
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	directory = _tmp1_;
#line 426 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_mkdir_with_parents (directory, 0755);
#line 428 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp2_ = uri;
#line 428 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp3_ = g_file_new_for_uri (_tmp2_);
#line 428 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	source = _tmp3_;
#line 429 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp4_ = filename;
#line 429 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp5_ = g_file_new_for_path (_tmp4_);
#line 429 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	dest = _tmp5_;
#line 431 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp6_ = callback;
#line 431 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp6__target = callback_target;
#line 431 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_file_copy_async (source, dest, G_FILE_COPY_OVERWRITE, G_PRIORITY_DEFAULT, NULL, NULL, NULL, _tmp6_, _tmp6__target);
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (dest);
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (source);
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (directory);
#line 3212 "currency.c"
}


static void currency_manager_download_imf_cb (CurrencyManager* self, GObject* object, GAsyncResult* _result_) {
	GFile* f = NULL;
	GObject* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (self != NULL);
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (_result_ != NULL);
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = object;
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, G_TYPE_FILE) ? ((GFile*) _tmp0_) : NULL);
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	f = _tmp1_;
#line 3231 "currency.c"
	{
		GAsyncResult* _tmp2_ = NULL;
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp2_ = _result_;
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_file_copy_finish (f, _tmp2_, &_inner_error_);
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3240 "currency.c"
			goto __catch4_g_error;
		}
#line 441 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_debug ("currency.vala:441: IMF rates updated");
#line 3245 "currency.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
#line 438 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		e = _inner_error_;
#line 438 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_inner_error_ = NULL;
#line 445 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp3_ = e;
#line 445 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp4_ = _tmp3_->message;
#line 445 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_warning ("currency.vala:445: Couldn't download IMF currency rate file: %s", _tmp4_);
#line 438 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_error_free0 (e);
#line 3265 "currency.c"
	}
	__finally4:
#line 438 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 438 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (f);
#line 438 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 438 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_clear_error (&_inner_error_);
#line 438 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return;
#line 3278 "currency.c"
	}
#line 448 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	downloading_imf_rates = FALSE;
#line 449 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	currency_manager_load_rates (self);
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (f);
#line 3286 "currency.c"
}


static void currency_manager_download_ecb_cb (CurrencyManager* self, GObject* object, GAsyncResult* _result_) {
	GFile* f = NULL;
	GObject* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 452 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (self != NULL);
#line 452 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (_result_ != NULL);
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = object;
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, G_TYPE_FILE) ? ((GFile*) _tmp0_) : NULL);
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	f = _tmp1_;
#line 3305 "currency.c"
	{
		GAsyncResult* _tmp2_ = NULL;
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp2_ = _result_;
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_file_copy_finish (f, _tmp2_, &_inner_error_);
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3314 "currency.c"
			goto __catch5_g_error;
		}
#line 458 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_debug ("currency.vala:458: ECB rates updated");
#line 3319 "currency.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
#line 455 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		e = _inner_error_;
#line 455 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_inner_error_ = NULL;
#line 462 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp3_ = e;
#line 462 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_tmp4_ = _tmp3_->message;
#line 462 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_warning ("currency.vala:462: Couldn't download ECB currency rate file: %s", _tmp4_);
#line 455 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_error_free0 (e);
#line 3339 "currency.c"
	}
	__finally5:
#line 455 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 455 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		_g_object_unref0 (f);
#line 455 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 455 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_clear_error (&_inner_error_);
#line 455 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		return;
#line 3352 "currency.c"
	}
#line 464 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	downloading_ecb_rates = FALSE;
#line 465 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	currency_manager_load_rates (self);
#line 452 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (f);
#line 3360 "currency.c"
}


CurrencyManager* currency_manager_construct (GType object_type) {
	CurrencyManager * self = NULL;
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	self = (CurrencyManager*) g_object_new (object_type, NULL);
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return self;
#line 3370 "currency.c"
}


CurrencyManager* currency_manager_new (void) {
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return currency_manager_construct (TYPE_CURRENCY_MANAGER);
#line 3377 "currency.c"
}


static void currency_manager_class_init (CurrencyManagerClass * klass) {
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	currency_manager_parent_class = g_type_class_peek_parent (klass);
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_type_class_add_private (klass, sizeof (CurrencyManagerPrivate));
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	G_OBJECT_CLASS (klass)->finalize = currency_manager_finalize;
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_signal_new ("updated", TYPE_CURRENCY_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3390 "currency.c"
}


static void currency_manager_instance_init (CurrencyManager * self) {
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	self->priv = CURRENCY_MANAGER_GET_PRIVATE (self);
#line 3397 "currency.c"
}


static void currency_manager_finalize (GObject* obj) {
	CurrencyManager * self;
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CURRENCY_MANAGER, CurrencyManager);
#line 18 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	__g_list_free__g_object_unref0_0 (self->priv->currencies);
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	G_OBJECT_CLASS (currency_manager_parent_class)->finalize (obj);
#line 3409 "currency.c"
}


GType currency_manager_get_type (void) {
	static volatile gsize currency_manager_type_id__volatile = 0;
	if (g_once_init_enter (&currency_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CurrencyManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) currency_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CurrencyManager), 0, (GInstanceInitFunc) currency_manager_instance_init, NULL };
		GType currency_manager_type_id;
		currency_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "CurrencyManager", &g_define_type_info, 0);
		g_once_init_leave (&currency_manager_type_id__volatile, currency_manager_type_id);
	}
	return currency_manager_type_id__volatile;
}


Currency* currency_construct (GType object_type, const gchar* name, const gchar* display_name, const gchar* symbol) {
	Currency * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
#line 482 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 482 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (display_name != NULL, NULL);
#line 482 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 482 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	self = (Currency*) g_object_new (object_type, NULL);
#line 484 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = name;
#line 484 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 484 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (self->priv->_name);
#line 484 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	self->priv->_name = _tmp1_;
#line 485 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp2_ = display_name;
#line 485 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 485 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (self->priv->_display_name);
#line 485 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	self->priv->_display_name = _tmp3_;
#line 486 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp4_ = symbol;
#line 486 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 486 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (self->priv->_symbol);
#line 486 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	self->priv->_symbol = _tmp5_;
#line 482 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return self;
#line 3467 "currency.c"
}


Currency* currency_new (const gchar* name, const gchar* display_name, const gchar* symbol) {
#line 482 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return currency_construct (TYPE_CURRENCY, name, display_name, symbol);
#line 3474 "currency.c"
}


void currency_set_value (Currency* self, Number* value) {
	Number* _tmp0_ = NULL;
	Number* _tmp1_ = NULL;
#line 489 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (self != NULL);
#line 489 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_if_fail (value != NULL);
#line 491 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = value;
#line 491 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 491 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (self->priv->value);
#line 491 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	self->priv->value = _tmp1_;
#line 3493 "currency.c"
}


Number* currency_get_value (Currency* self) {
	Number* result = NULL;
	Number* _tmp0_ = NULL;
	Number* _tmp1_ = NULL;
#line 494 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 496 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = self->priv->value;
#line 496 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 496 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	result = _tmp1_;
#line 496 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return result;
#line 3511 "currency.c"
}


gchar* currency_get_name (Currency* self) {
	gchar* result;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 474 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 474 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = self->priv->_name;
#line 474 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 474 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	result = _tmp1_;
#line 474 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return result;
#line 3529 "currency.c"
}


gchar* currency_get_display_name (Currency* self) {
	gchar* result;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = self->priv->_display_name;
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	result = _tmp1_;
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return result;
#line 3547 "currency.c"
}


gchar* currency_get_symbol (Currency* self) {
	gchar* result;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp0_ = self->priv->_symbol;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	result = _tmp1_;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	return result;
#line 3565 "currency.c"
}


static void currency_class_init (CurrencyClass * klass) {
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	currency_parent_class = g_type_class_peek_parent (klass);
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_type_class_add_private (klass, sizeof (CurrencyPrivate));
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_currency_get_property;
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	G_OBJECT_CLASS (klass)->finalize = currency_finalize;
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CURRENCY_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CURRENCY_DISPLAY_NAME, g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CURRENCY_SYMBOL, g_param_spec_string ("symbol", "symbol", "symbol", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 3584 "currency.c"
}


static void currency_instance_init (Currency * self) {
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	self->priv = CURRENCY_GET_PRIVATE (self);
#line 3591 "currency.c"
}


static void currency_finalize (GObject* obj) {
	Currency * self;
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CURRENCY, Currency);
#line 471 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_object_unref0 (self->priv->value);
#line 473 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (self->priv->_name);
#line 476 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (self->priv->_display_name);
#line 479 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	_g_free0 (self->priv->_symbol);
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	G_OBJECT_CLASS (currency_parent_class)->finalize (obj);
#line 3609 "currency.c"
}


GType currency_get_type (void) {
	static volatile gsize currency_type_id__volatile = 0;
	if (g_once_init_enter (&currency_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CurrencyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) currency_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Currency), 0, (GInstanceInitFunc) currency_instance_init, NULL };
		GType currency_type_id;
		currency_type_id = g_type_register_static (G_TYPE_OBJECT, "Currency", &g_define_type_info, 0);
		g_once_init_leave (&currency_type_id__volatile, currency_type_id);
	}
	return currency_type_id__volatile;
}


static void _vala_currency_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Currency * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CURRENCY, Currency);
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
	switch (property_id) {
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		case CURRENCY_NAME:
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_value_take_string (value, currency_get_name (self));
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		break;
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		case CURRENCY_DISPLAY_NAME:
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_value_take_string (value, currency_get_display_name (self));
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		break;
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		case CURRENCY_SYMBOL:
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		g_value_take_string (value, currency_get_symbol (self));
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		break;
#line 3648 "currency.c"
		default:
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 469 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/currency.vala"
		break;
#line 3654 "currency.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



